; Especificaciones: Ejercicio página 213 para ZX Spectrum 16K/48K.
; Descripción general: CIRCLE.
; Longitud: 44 bytes.
; Entrada: Ningún requerimiento.
; Salida: Circunferencias varias en memoria de pantalla.
; Registros usados: A, B y C en programa.
;                   A, B, C, D, E, H y L en rutina ROM.
; Nota importate: El registro doble alternativo H'L' debe ser
; guardado antes de ka llamada a la rutina CIRCLE, y restaurado
; antes del retorno al BASIC.
org		$7000

circle	equ $232d
cls		equ $0d6b
open	equ	$1601
stack_a	equ	$2d28

Inicio:
	call	cls			; Limpia la pantalla
	ld		a, $02
	call	open		; Abre el canal 2
	exx					; Set alternativo
	push	hl			; Preserva H'L'
	exx					; Set normal

	ld		b, 0		; B = 0, contador
Bucle:
	ld		a, b		; Coordenada X
	push	bc			; Preserva BC
	call	stack_a		; Guarda en la pila del calculador
	pop		bc			; Recupera BC
	
	ld		a, b		; Coordenada Y
	push	bc			; Preserva BC
	call	stack_a		; Guarda en la pila del calculador
	pop		bc			; Recupera BC
	
	ld		a, b		; Radio
	push	bc			; Preserva BC
	call	stack_a		; Guarda en la pila del calculador
	call	circle		; CIRCLE x,y,radio
	pop		bc			; Recupera BC

	inc		b			; B=B+1
	ld		a, 87		; A = Valor maximo
	cp		b			; ¿B = 87?
	jr		nz,	Bucle	; B<>87 sigue bucle

Fin:
	exx					; Set alternativo
	pop		hl			; Recupera H'L'
	exx					; Set normal
	ret					

end		$7000