; Especificaciones: RELABEL para ZX Spectrum 16K/48K.
; Descripción general: El programa renumera cada sentencia de un 
; programa BASIC.
; Longitud: 143 bytes + 11 bytes de Move.
; Entrada: Ningún requerimiento.
; Salida: Ningún requerimiento.
; Registros usados: A, B, C, D, E, H y L.
; Nota importante: se ejecuta desde BASIC con RANDOMIZE USR 23296
;		Para cambiar la línea inicial, por ejemplo a 5
;			POKE 23304,5: POKE 23305,0		5=5+0*256
;		Para cambiar el paso, por ejemplo a 1000
;			POKE 23317,232: POKE 23318,e	1000 = 232+3*256
org		$7000

buffer		equ $5b00
open		equ $1601
pr_string	equ $203c
prog		equ $5c53
vars		equ $5c4b

Move:
	; Para cargar el programa en el buffer de la impresora
	; tal y como indica en el libro.
	; Si se pone el ORG al buffer da un error de RAMTOP
	ld		hl, Main
	ld		de, buffer
	ld		bc, MsgEnd-Msg
	ldir
Main:
	ld		hl, (prog)			; HL = inicio del Basic
	ld		bc, (vars)			; BC = fin del Basic + 1
	ld		de, 10				; DE = línea inicial
Sig:
	push	bc					; Almacena BC
	ld		(hl), d				; Modifica el byte alto
	inc		hl
	ld		(hl), e				; Modifica el byte bajo
	inc		hl
	ld		c, (hl)				; C = byte bajo long.
	inc		hl
	ld		b, (hl)				; B = byte alto long.
	inc		hl
	add		hl, bc				; HL = sentencia sig.
	ld		bc, 10				; BC = paso
	ld		a, c
	add		a, e
	ld		e, a				; E = E + C				
	ld		a, b
	adc		a, d
	ld		d, a				; D = D + B
	pop		bc					; Recupera Vars
	ld		(23728), hl			; Guarda el puntero
	ld		hl, 55536			; HL = 65536 - 10000
	add		hl, de				; HL = HL + DE
	jr		c, Err				; Si DE > 9999 Error
	ld		hl, (23728)			; Recupera el puntero
	ld		(23728), hl			; Y guardalo otra vez
	xor		a					; Indic arrastre = 0
	sbc		hl, bc				; ¿Hemos acabado?
	ret		z					; Retorna si es así
	ld		hl, (23728)			; Recupera puntero
	jr		Sig					; Procesa la siguiente línea
Err:
	ld		a, 2				; Abre
	call	open				; canal número 2
	ld		de, Msg				; Dirección del mensaje
	ld		bc, 74				; Longitud del mensaje
	jp		pr_string			; Imprímelo
Msg:
	db		16, 2, 13, 18, 1	; AT 2,13; FLASH 1
	db		"ERROR"
	db		18, 0, 13, 13		; FLASH 0, Enter, Enter
	db		"El n. de linea excede la 9999."
	db		13
	db		"Modifica linea inicial o paso."
MsgEnd:

end		$7000