; Muestra el modelo de ZX Spectrum y el modo
org		$5dad

cls:		equ $0d6b	; Limpia la pantalla
libre1		equ	$5cb0	; Dirección libre donde se puede guardar un byte
libre2		equ $5cb1	; Dirección libre donde se puede guardar un byte
open:		equ $1601	; Abre el canal
prints:		equ $203c	; Imprime una cadena, DE = posición de la cadena, BC = longitud
tipo:		equ $4b		; Dirección donde se encuentra el tipo
t128:		equ $6e		; Tipo si es 128
modo16:		equ $5cb5	; Dirección dónde se sabe si es 16K
modo128:	equ $5c3b	; Dirección donde se encuenta el modo
m16:		equ $7f		; Modo si es 16
m128:		equ $dd		; Modo si esta en 128
mem48:		equ $ffff	; Memoria si es 48

Inicio:
	call	cls						; Limpia la pantalla
	ld		a, $02
	call	open					; Abre el canal 2

Calculo:
	ld		hl, libre1
	ld		de, val48
	ld		[hl], e
	inc		hl
	ld		[hl], d
	ld		hl, val48
	dec		hl
	ld		a, [tipo]				; A = tipo de ZX, 128 o 16/48
	cp		t128					; Evalúa si es 128
	jr		z, Zx128				; Si es 128 salta
	ld		a, [modo16]				; A = dirección para saber si es 16
	cp		m16						; Comprueba si es 16
	jr		z, Zx16
	jr		Fin						; Si no es 16 (es 48) salta

Zx16:
	ld		hl, libre1
	ld		de, val16
	ld		[hl], e
	inc		hl
	ld		[hl], d
	ld		hl, val16
	jr		Fin

Zx128:
	ld		hl, val128
	ld		a, [modo128]			; A = dirección para saber el modo
	cp		m128					; Evalúa si es 128
	jr		nz, Fin					; Si no es 128 (es 48) salta
	push	hl
	ld		hl, libre1				; Es 128K en modo 128
	ld		de, val128
	ld		[hl], e
	inc		hl
	ld		[hl], d
	pop		hl

Fin:
	ld		de, memTit
	ld		bc, modTit-memTit
	call	prints

	push	hl
	pop		de
	ld		bc, $03
	call	prints

	ld		de, modTit
	ld		bc, val16-modTit
	call	prints

	ld		de, [libre1]
	ld		bc, $03
	call	prints

	ret

memTit:
	db		$16, $0a, $0a
	defm	"Memoria: "
	db		$17, $13, $00
modTit:
	db		$16, $0c, $0a
	defm	"Modo: "
	db		$17, $13, $00
val16:
	db		"16 "
val48:
	db		"48 "
val128:
	db		"128"

finStr:

end		$5dad